# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright DinkoO(C) 2012
# Dinko Osmankovic
# dinko.osmankovic@etf.unsa.ba
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

# This is your preferences dialog.
#
# Define your preferences in
# data/glib-2.0/schemas/net.launchpad.fuelexpensestracker.gschema.xml
# See http://developer.gnome.org/gio/stable/GSettings.html for more info.

from gi.repository import Gio # pylint: disable=E0611

import gettext
from gettext import gettext as _
gettext.textdomain('fuelexpensestracker')

import logging
logger = logging.getLogger('fuelexpensestracker')

from fuelexpensestracker_lib.PreferencesDialog import PreferencesDialog

class PreferencesFuelexpensestrackerDialog(PreferencesDialog):
    __gtype_name__ = "PreferencesFuelexpensestrackerDialog"

    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the preferences dialog"""
        super(PreferencesFuelexpensestrackerDialog, self).finish_initializing(builder)

        # Bind each preference widget to gsettings
        settings = Gio.Settings("net.launchpad.fuelexpensestracker")
        combo_Currency = self.builder.get_object('combo_Currency')
        combo_Currency.set_active(settings.get_int("currencyindex"))

        combo_Volume = self.builder.get_object('combo_Volume')
        combo_Volume.set_active(settings.get_int("volumeindex"))

        combo_Distance = self.builder.get_object('combo_Distance')
        combo_Distance.set_active(settings.get_int("distanceindex"))

        # Code for other initialization actions should be added here.

    def on_combo_Currency_changed(self, widget, data=None):
        settings = Gio.Settings("net.launchpad.fuelexpensestracker")
        combo_Currency = self.builder.get_object('combo_Currency')
        settings.set_int("currencyindex", combo_Currency.get_active())
        model = combo_Currency.get_model()
        value = model.get_value(model.get_iter(combo_Currency.get_active()) , 2)
        settings.set_double("currencymultiplier", value)
        
    def on_combo_Volume_changed(self, widget, data=None):
        settings = Gio.Settings("net.launchpad.fuelexpensestracker")
        combo_Volume = self.builder.get_object('combo_Volume')
        settings.set_int("volumeindex", combo_Volume.get_active())
        model = combo_Volume.get_model()
        value = model.get_value(model.get_iter(combo_Volume.get_active()) , 2)
        settings.set_double("volumemultiplier", value)

    def on_combo_Distance_changed(self, widget, data=None):
        settings = Gio.Settings("net.launchpad.fuelexpensestracker")
        combo_Distance = self.builder.get_object('combo_Distance')
        settings.set_int("distanceindex", combo_Distance.get_active())
        model = combo_Distance.get_model()
        value = model.get_value(model.get_iter(combo_Distance.get_active()) , 2)
        settings.set_double("distancemultiplier", value)
